AC_DEFUN([READLINE_CHECK],
[
  READLINE_CFLAGS=""
  READLINE_LIBS="-lreadline"

  OLD_CFLAGS=$CFLAGS
  OLD_LIBS=$LIBS
  CFLAGS="$CFLAGS $READLINE_CFLAGS"
  LIBS="$LIBS $READLINE_LIBS"

  AC_CHECK_LIB([readline], [readline],, READLINE_ERROR)
  AC_MSG_CHECKING([for the readline library])
  AC_TRY_LINK(
  [
    #include <stdio.h>
    #include <readline/readline.h>
    #include <readline/history.h>
  ],
  [
    char *c;
    c = readline("> ");
    add_history(c);
  ],
  [
    AC_MSG_RESULT([yes])
    AC_SUBST(READLINE_CFLAGS)
    AC_SUBST(READLINE_LIBS)
  ],
  [
    AC_MSG_RESULT([no])
    READLINE_ERROR
  ])

  CFLAGS=$OLD_CFLAGS
  LIBS=$OLD_LIBS
])

AC_DEFUN([READLINE_ERROR],
[
  AC_MSG_ERROR([$PACKAGE requires the readline library development package
])
])
