#ifndef CACHE_H
#define CACHE_H

#include<stdio.h>
#include"sim.h"

typedef struct cache_entry
{
    queue_t*        queue;      // Pointer to the queue associated with it.
    int             time;       // Sim time - not always needed.
    u_char*         packet;     // Contents of the packet, including timestamp.
    unsigned int    len;
    int             id;
} cache_entry_t;

typedef struct packet_cache
{
    cache_entry_t** cache;
    int size;
    int index;
} packet_cache_t;

packet_cache_t* packet_cache_init(int size);
void packet_cache_delete(packet_cache_t* cache);

void packet_cache_insert(packet_cache_t* cache, queue_t* queue,
                         const u_char* packet, unsigned int len, int id);
void packet_cache_free(packet_cache_t* cache, queue_t* queue);
png_t* packet_cache_png_find(packet_cache_t* cache, queue_t* queue);

// Debugging
void packet_cache_stats(FILE* flog, packet_cache_t* cache, queue_t* queue);
void packet_cache_show_pngs_for_offset(packet_cache_t* cache, queue_t* queue, int offset);


extern packet_cache_t* cache;

#endif /* CACHE_H */
