#ifndef NA_CONFIG_H
#define NA_CONFIG_H

#include<stdbool.h>

typedef struct config config_t;

struct config {
    const char  *interface;

    char const **files;
    int          numfiles;

    bool         database_output;
    const char  *database_host;
    int          database_port;
    const char  *database_name;
    const char  *database_tree;
    const char  *database_user;
    const char  *database_pass;

    bool         dot_output;
    const char  *dot_file;

    bool         interactive;
    bool         noheaders;   // pngrams can come from headers?
    bool         ip_only;
    bool         ignore_port;
    bool         verbose;
    bool         by_file;
};

config_t* config_load(int argc, char **argv);
void config_free(config_t *c);

#endif
