#include"util.h"

#include<string.h>
#include<stdlib.h>
#include<stdio.h>

static char BUFFER[256];
char* token_get(FILE* fin)
{
    if(feof(fin)) {
        BUFFER[0] = '\0';
        goto ret;
    }

    int c = (int)fgetc(fin);
    if(c == '\0' || c == 4 || c == -1) {
        BUFFER[0] = '\0';
        goto ret;
    }

    while(c == ' ' || c == '\n' || c == '\t') 
        c = (char)fgetc(fin);
 
    if( c == ')' || c == '(' || c == ',' ) {
        BUFFER[0] = c;
        BUFFER[1] = '\0';
        goto ret;
    }
        
    int i=0;
    while(c != ' ' && c != '\n' && c != '\t' && c != '\0' && c !='(' && c != ',' && c != ')'  && c != 4 && c!= -1) {
        BUFFER[i++] = c;
        c = (char)fgetc(fin);
    } 

    ungetc(c, fin);
    BUFFER[i] = '\0';
ret: 
    return BUFFER;
}

void token_put(FILE* file, char* token)
{
    int len = strlen(token);
    int i; for(i=len-1; i >= 0; i--) {
        int ret = ungetc(token[i], file);
        if(ret == EOF) { fprintf(stderr, "ERROR PUSHING BACK.\n"); exit(0); }
    }
}

gboolean eol(FILE* fin)
{
    int i=0;
    gboolean ret = FALSE;
    BUFFER[i]=fgetc(fin);
    while(BUFFER[i] == '\t' || BUFFER[i] == ' ' || BUFFER[i] == '\f' )
    {
        BUFFER[++i] = fgetc(fin);
    }

    if(BUFFER[i] == '\n') ret = TRUE;

    BUFFER[++i] = '\0';
    token_put(fin, BUFFER);

    return ret;
}

char* token_peek(FILE* file)
{
    char* token = token_get(file);
    token_put(file, token);
    return token;
}

char* chop(char* line)
{
    int length = strlen(line);
    char* last = line + length - 1;

    while(TRUE)
    {
        if ( *last >= '!' && *last <= '~' )
            break;
        else
            *last = '\0';

        last--;
    }

    return line;
}

gboolean parse_bytes(char* token, char* vals, int len)
{
    char tmp[3];
    tmp[2] = '\0';

    int i; for(i=0; i < len; i++)
    {
        int val = 0;
        tmp[0] = token[i*2];
        tmp[1] = token[i*2+1];
        val = strtol(tmp, NULL, 16); 
        vals[i] = (unsigned char)val;
    }

    return TRUE;
}

gboolean parse_long(char* line, int* ret)
{
    g_assert(line != NULL && ret != NULL);
    char* endptr;
    int val = strtol(line, &endptr, 10);

    if(endptr[0] == '\0')
    {
        *ret = val;
        return TRUE;
    }

    return FALSE;
}

#ifdef UTIL_MAIN
int main(int argc, char* argv[])
{
    FILE* file =fopen(argv[1], "r");
    char* token=get_token(file);
    while(token[0] != '\0') {
        fprintf(stderr, "%s\n", token);
        token = get_token(file);
    }
}
#endif // UTIL_MAIN
